<?php
define('MODULE_PAYMENT_YOURPAY', 'TRUE');
define('MODULE_PAYMENT_YOURPAY_TEXT_CATALOG_TITLE', "https://payments.yourpay.eu/img/kortlogo_visa_mastercard_verified_visadankort.png");
define('MODULE_PAYMENT_TEXT_DESCRIPTION', "Accept Mastercard and Visacard with Yourpay");
define('MODULE_PAYMENT_YOURPAY_ENTRY_CAPTURE_BUTTON_TEXT_FULL', "refund yourpay payment");
define('YOURPAY_ORDERSTATUS_DELIVERED_ID', 1703);
define('YOURPAY_ORDERSTATUS_DELIVERED', 'YOURPAY: Delivered');  // not used
define('YOURPAY_ORDERSTATUS_CLOSED_ID', 1701);     // Added to zencart orders_status table on install
define('YOURPAY_ORDERSTATUS_CLOSED', 'YOURPAY: Cancelled');
define('YOURPAY_ORDERSTATUS_CREDITED_ID', 1702);   // Added to zencart orders_status table on install
define('YOURPAY_ORDERSTATUS_CREDITED', 'Yourpay: Credited');


class yourpay extends base
{
    var $code;
    var $title;
    var $description;
    var $enabled;

    function __construct()
    {
        $this->enabled = 'true';

        global $order, $messageStack;
        $this->code = 'yourpay';
        $this->codeversion = '1.4';
        $this->sort_order = defined('MODULE_PAYMENT_YOURPAY_SORT_ORDER') ? MODULE_PAYMENT_YOURPAY_SORT_ORDER : null;
        $this->enabled = (defined('MODULE_PAYMENT_YOURPAY_STATUS') && MODULE_PAYMENT_YOURPAY_STATUS == 'True');
        $this->title="Yourpay";
        $this->public_title="Yourpay";
        $this->merchant_token=MODULE_PAYMENT_YOURPAY_MERCHANT_TOKEN;

        if (IS_ADMIN_FLAG === true) {
            if (IS_ADMIN_FLAG === true && defined('MODULE_PAYMENT_YOURPAY_IPN_DEBUG') && MODULE_PAYMENT_YOURPAY_IPN_DEBUG != 'off') $this->title .= '<span class="alert">(debug mode active)</span>';
            if (IS_ADMIN_FLAG === true && defined('MODULE_PAYMENT_YOURPAY_TESTING') && MODULE_PAYMENT_YOURPAY_TESTING == 'Test') $this->title .= '<span class="alert"> (dev/test mode active)</span>';
        } else {
            $this->title = "Betalingskort";
        }
        if (null === $this->sort_order) return false;

        $this->description = MODULE_PAYMENT_TEXT_DESCRIPTION;
        if (defined('MODULE_PAYMENT_YOURPAY_ORDER_STATUS_ID') && (int)MODULE_PAYMENT_YOURPAY_ORDER_STATUS_ID > 0) {
            $this->order_status = MODULE_PAYMENT_YOURPAY_ORDER_STATUS_ID;
        }

        if ('MODULE_PAYMENT_YOURPAY_HANDLER' == 'live' || !strstr('MODULE_PAYMENT_YOURPAY_HANDLER', 'sandbox')) {
            $this->form_action_url = $this->generate_token();// 'https://webservice.yourpay.dk/v4.3/generate_token?';

        }
        // determine order-status for transactions
        if (defined('MODULE_PAYMENT_YOURPAY_ORDER_STATUS_ID') && (int)MODULE_PAYMENT_YOURPAY_ORDER_STATUS_ID > 0) {
            $this->order_status = MODULE_PAYMENT_YOURPAY_ORDER_STATUS_ID;
        }
        if (defined('MODULE_PAYMENT_YOURPAY_TRANSACTION_TYPE') && MODULE_PAYMENT_YOURPAY_TRANSACTION_TYPE == 'authorize') {
            $this->order_status = 1;
        }
        if ($this->merchant_token == ''||$this->merchant_token=="Enter merchant token in this field") {
            $this->title       .= '<span class="alert"> (Access Token needed)</span>';
            $this->enabled=false;
        }
    }

    function check()
    {
        global $db, $sniffer;
        if($sniffer->table_exists(TABLE_YOURPAY_PAYMENTS)){
            if($db->Execute("DESCRIBE `TABLE_YOURPAY_PAYMENTS` `order_id`")->fields["Type"] == "int(11)")
                $db->Execute("DROP Table `TABLE_YOURPAY_PAYMENTS`");
        }
        if (!$sniffer->table_exists(TABLE_YOURPAY_PAYMENTS)) {
            $sql = "
            CREATE TABLE `" . TABLE_YOURPAY_PAYMENTS . "` (
                `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
              `order_id` varchar(255) NOT NULL,
              `transaction_id` varchar(255) NOT NULL,
              `value` int(11) UNSIGNED NOT NULL,
              PRIMARY KEY (`id`)
            )";
            $db->Execute($sql);
        };
        if (IS_ADMIN_FLAG === true) {
            global $sniffer;
            if ($sniffer->field_exists(TABLE_YOURPAY_PAYMENTS, 'zen_order_id')) $db->Execute("ALTER TABLE " . TABLE_YOURPAY_PAYMENTS . " CHANGE COLUMN zen_order_id order_id int(11) NOT NULL default '0'");
        }
        if (!isset($this->_check)) {
            $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_YOURPAY_STATUS'");
            $this->_check = $check_query->RecordCount();
        }
        if (defined('MODULE_PAYMENT_YOURPAY_HANDLER') && !in_array(MODULE_PAYMENT_YOURPAY_HANDLER, array('live', 'sandbox'))) {
            $val = (stristr(MODULE_PAYMENT_YOURPAY_HANDLER, 'sand')) ? 'sandbox' : 'live';
            $sql = "UPDATE " . TABLE_CONFIGURATION . " SET configuration_title = 'Live or Sandbox', configuration_value = '" . $val . "', configuration_description= '<strong>Live: </strong> Used to process Live transactions<br><strong>Sandbox: </strong>For developers and testing', set_function='zen_cfg_select_option(array(\'live\', \'sandbox\'), ' WHERE configuration_key = 'MODULE_PAYMENT_YOURPAY_HANDLER'";
            $db->Execute($sql);
        }

        return $this->_check;
    }

    function keys()
    {
        $keys_list = array(
            'MODULE_PAYMENT_YOURPAY_STATUS',
            'MODULE_PAYMENT_YOURPAY_BUSINESS_ID',
            'MODULE_PAYMENT_YOURPAY_PDTTOKEN',
            'MODULE_PAYMENT_YOURPAY_CURRENCY',
            'MODULE_PAYMENT_YOURPAY_ZONE',
            'MODULE_PAYMENT_YOURPAY_PROCESSING_STATUS_ID',
            'MODULE_PAYMENT_YOURPAY_ORDER_STATUS_ID',
            'MODULE_PAYMENT_YOURPAY_REFUND_ORDER_STATUS_ID',
            'MODULE_PAYMENT_YOURPAY_SORT_ORDER',
            'MODULE_PAYMENT_YOURPAY_DETAILED_CART',
            'MODULE_PAYMENT_YOURPAY_ADDRESS_OVERRIDE',
            'MODULE_PAYMENT_YOURPAY_ADDRESS_REQUIRED',
            'MODULE_PAYMENT_YOURPAY_PAGE_STYLE',
            'MODULE_PAYMENT_YOURPAY_HANDLER',
            'MODULE_PAYMENT_YOURPAY_IPN_DEBUG',
            'MODULE_PAYMENT_YOURPAY_MERCHANT_TOKEN',
            'MODULE_PAYMENT_YOURPAY_TRANSACTION_TYPE',
            'MODULE_PAYMENT_YOURPAY_USETEST',
            'MODULE_PAYMENT_YOURPAY_ENTRY_CAPTURE_BUTTON_TEXT_FULL',
            'MODULE_PAYMENT_YOURPAY_REFUNDED_ORDER_STATUS_ID',
            'YOURPAY_ORDERSTATUS_DELIVERED_ID',
            'YOURPAY_ORDERSTATUS_CREDITED_ID,',
            'YOURPAY_ORDERSTATUS_CLOSED_ID'
        );

        if (IS_ADMIN_FLAG === true) {
            if (isset($_GET['debug']) && $_GET['debug'] == 'on') {
                $keys_list[] = 'MODULE_PAYMENT_YOURPAY_DEBUG_EMAIL_ADDRESS';  /* this defaults to store-owner-email-address */
            }
        }
        return $keys_list;
    }

    public function install()
    {
        global $db;

        if (!defined('MODULE_PAYMENT_YOURPAY_STATUS')) $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable yourpay Module', 'MODULE_PAYMENT_YOURPAY_STATUS', 'True', 'Do you want to accept yourpay payments?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
        if (!defined('MODULE_PAYMENT_YOURPAY_TRANSACTION_TYPE')) $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Type', 'MODULE_PAYMENT_YOURPAY_TRANSACTION_TYPE', 'purchase', 'Should payments be [authorized] only, or be completed [purchases]?<br>NOTE: Purchases may only be active if you are selling virtual products.', '6', '0', 'zen_cfg_select_option(array(\'authorize\', \'purchase\'), ', now())");
        if (!defined('MODULE_PAYMENT_YOURPAY_MERCHANT_TOKEN')) $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order) values ('Merchant Token', 'MODULE_PAYMENT_YOURPAY_MERCHANT_TOKEN', 'Enter merchant token in this field', '', '6', '2')");
        if (!defined('MODULE_PAYMENT_YOURPAY_ZONE')) $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_YOURPAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
        if (!defined('MODULE_PAYMENT_YOURPAY_SORT_ORDER')) $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('<hr>Sort order of display.', 'MODULE_PAYMENT_YOURPAY_SORT_ORDER', '0', 'Sort order of displaying payment options to the customer. Lowest is displayed first.', '6', '0', now())");
        if (!defined('MODULE_PAYMENT_YOURPAY_USETEST')) $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Type', 'MODULE_PAYMENT_YOURPAY_USETEST', '', 'Set Yourpay to run in [Test] while webshop is under development. Use [production] when your shop is ready to go online <br>', '7', '3', 'zen_cfg_select_option(array(\'Test\', \'production\'), ', now())");


        $res = $db->Execute('SELECT COUNT(*) FROM ' . TABLE_ORDERS_STATUS . ' WHERE orders_status_id = "'. YOURPAY_ORDERSTATUS_CLOSED_ID .'"');
        if( $res->fields["COUNT(*)"] == 0 ) {
            $sql =  'INSERT INTO ' . TABLE_ORDERS_STATUS . ' (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ' .
                '(' . YOURPAY_ORDERSTATUS_CLOSED_ID . ', 1, "' . YOURPAY_ORDERSTATUS_CLOSED . '"), ' .
                '(' . YOURPAY_ORDERSTATUS_CREDITED_ID . ', 1, "' . YOURPAY_ORDERSTATUS_CREDITED . '"), ' .
                '(' .YOURPAY_ORDERSTATUS_DELIVERED_ID. ', 1, "' . YOURPAY_ORDERSTATUS_DELIVERED . '")'
            ;
            $db->Execute( $sql );
        }
        $this->notify('MODULES_PAYMENT_YOURPAY_INSTALLED');
    }

    public function v43requestresponse($method, $data = array()) {
        $url = "https://webservice.yourpay.dk/v4.3/".$method;
        $fields_string = array("merchant_token" => $this->merchant_token);

        $ch = curl_init();
        foreach ($data as $key => $value) {
            $fields_string[$key] = urlencode("$value");
        }
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($fields_string));
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $server_output = curl_exec($ch);
        curl_close($ch);

        return json_decode($server_output)->content;
    }

    public function getmerchantid() {
        $customer_data = $this->v43requestresponse("customer_data");

        $merchantid = 0;

        if(MODULE_PAYMENT_YOURPAY_USETEST == 'Test')
            $merchantid = $customer_data->merchant_id;
        else if(MODULE_PAYMENT_YOURPAY_USETEST=='Production')
            $merchantid = $customer_data->production_id;

        return $merchantid;
    }

    public function createcartid(){
        global $cart_id;
        $cart_id=zen_create_random_value(2);
        return $cart_id;
    }

    public function generate_token() {
        global $order;

        $checkoutSessionRequest = array();
        $checkoutSessionRequest["amount"] = $order->info['total']*100;
        $checkoutSessionRequest["currency"] = $order->info['currency'];
        $checkoutSessionRequest["cartid"] = $this->createcartid();
        $checkoutSessionRequest["consumer_name"] = $order->costumer['firstname']+$order->costumer['lastname'];
        $checkoutSessionRequest["phone"] = $order->customer['telephone'];
        $checkoutSessionRequest["language"]=$this->get_language_code();
        $checkoutSessionRequest["MerchantNumber"] = $this->getmerchantid();
        $checkoutSessionRequest["accepturl"]=zen_href_link(FILENAME_CHECKOUT_PROCESS, zen_session_name().'='.zen_session_id(),'SSL');
        $checkoutSessionRequest["ShopPlatform"]="Zen cart - V".$this->codeversion;
        // x.x.x.x.

        $generate_url = $this->v43requestresponse("generate_token", $checkoutSessionRequest);

        return $generate_url->full_url;
    }
    public function get_language_code(){
        switch ($_SESSION["languages_code"]) {
            case "dk":
                return "da-dk";
                break;
            case "en":
                return "da-dk";
                break;
            case "no":
                return "nb-no";
                break;
            case "se":
                return "se-se";
                break;
            case "fi":
                return "fi-fi";
                break;
            case "de":
                return "de-de";
                break;
            case "fr":
                return "fr-fr";
                break;
        }
    }

    public function remove()
    {
        global $db;
        $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE\_PAYMENT\_YOURPAY\_%'");
    }
    public function selection() {
        return array(
            'id'     => $this->code,
            'module'=> "Yourpay<br/><img src='https://payments.yourpay.eu/img/kortlogo_visa_mastercard_verified_visadankort.png'/>");
    }
    public function javascript_validation()
    {
        return false;
    }
    function pre_confirmation_check() {
        $this->generate_token();
        return false;
    }
    function confirmation(){
        return false;
    }
    function process_button(){
        return false;
    }
    function before_process(){
        global $order, $insert_id;
        $yourpay_order = array(
            'order_id'=>$_GET['orderid'],
            'transaction_id'=>$this->gettransactionid(),
            'value'=>$order->info['total']*100
        );

        zen_db_perform(TABLE_YOURPAY_PAYMENTS,$yourpay_order);

        $this->notify('NOTIFY_YOURPAY_AFTER_PROCESS_FINISHED', $yourpay_order);

        if(MODULE_PAYMENT_YOURPAY_TRANSACTION_TYPE=='authorize'){
            $captureurl=0;
        }else if (MODULE_PAYMENT_YOURPAY_TRANSACTION_TYPE=='purchase'){

            $captureSessionRequest = array();
            $captureSessionRequest["MerchantNumber"] = $this->getmerchantid();
            $captureSessionRequest["id"]=$this->gettransactionid();
            $captureSessionRequest["amount"]=$order->info['total']*100;
            $captureurl = $this->v43requestresponse("payment_action", $captureSessionRequest);
        }
        return $captureurl;
    }
    public function gettransactionid(){
        $transactionid=$_GET['tid'];
        return $transactionid;
    }
    function after_process(){
        global  $insert_id, $db, $insertoid;
        $insertoid=$db->Execute("UPDATE `TABLE_YOURPAY_PAYMENTS` SET order_id ='".$insert_id."' WHERE transaction_id ='".$this->gettransactionid()."'");
        return $insertoid;
    }

    function latecaptid(){
        global $db, $orderid;
        $orderid=$_GET['oID'];
        $latetid = $db->Execute("SELECT `transaction_id` FROM `TABLE_YOURPAY_PAYMENTS` WHERE `order_id`=". $orderid );
        $latetidarray = array();
        while(!$latetid->EOF) {
            $latetidarray[] = $latetid->fields;
            $latetid->MoveNext();
        }

// now let's output it
        foreach($latetidarray as $item) {
            return $item['transaction_id'];
        }

    }


    function latecaptamount(){
        global $db, $orderid;
        $orderid=$_GET['oID'];
        $lateamount = $db->Execute("SELECT `value` FROM `TABLE_YOURPAY_PAYMENTS` WHERE `order_id`=". $orderid );
        $lateamountarray = array();
        while(!$lateamount->EOF) {
            $lateamountarray[] = $lateamount->fields;
            $lateamount->MoveNext();
        }

// now let's output it
        foreach($lateamountarray as $item) {
            return $item['value'];
        }}


//todo create ability to capture at specific stage
    function _doStatusUpdate($oID, $status) {


        switch ($status){
            case YOURPAY_ORDERSTATUS_DELIVERED_ID:
                $latecaptureSessionRequest = array();
                $latecaptureSessionRequest["merchant_token"] = $this->merchant_token;
                $latecaptureSessionRequest["id"]=$this->latecaptid();
                $latecaptureSessionRequest["amount"]=$this->latecaptamount();
                $latecaptureurl = $this->v43requestresponse("payment_action", $latecaptureSessionRequest);

                return $latecaptureurl;

            case YOURPAY_ORDERSTATUS_CLOSED_ID:
                $laterefundSessionrequest = array();
                $laterefundSessionrequest["merchant_token"] = $this->merchant_token;
                $laterefundSessionrequest["id"] = $this->latecaptid();
                $laterefundurl = $this->v43requestresponse("payment_release", $laterefundSessionrequest);
                return $laterefundurl;

            case YOURPAY_ORDERSTATUS_CREDITED_ID:
                $latecaptureSessionRequest = array();
                $latecaptureSessionRequest["merchant_token"] = $this->merchant_token;
                $latecaptureSessionRequest["id"]=$this->latecaptid();
                $latecaptureSessionRequest["amount"]=$this->latecaptamount();
                $latecaptureurl = $this->v43requestresponse("payment_action", $latecaptureSessionRequest);

                return $latecaptureurl;
        }


        /*if(YOURPAY_ORDERSTATUS_DELIVERED_ID){
            print_r("delivered");
                    die();
                    $latecaptureSessionRequest = array();
                    $latecaptureSessionRequest["merchant_token"] = $this->merchant_token;
                    $latecaptureSessionRequest["id"]=$this->latecaptid();
                    $latecaptureSessionRequest["amount"]=$this->latecaptamount();
                    $latecaptureurl = $this->v43requestresponse("payment_action", $latecaptureSessionRequest);

                    return $latecaptureurl;

            }else if($status==YOURPAY_ORDERSTATUS_CLOSED_ID) {
            print_r("closed");
            die();
            $laterefundSessionrequest = array();
            $laterefundSessionrequest["merchant_token"] = $this->merchant_token;
            $laterefundSessionrequest["id"] = $this->latecaptid();
            $laterefundurl = $this->v43requestresponse("payment_release", $laterefundSessionrequest);
            return $laterefundurl;

            }else if ($this->order_status==YOURPAY_ORDERSTATUS_CREDITED_ID){
            print_r("credited");
            die();
        }*/

    }
}//end
